public class PlayDeck {
  /**/
  private CardStack up, down;
  /**/
  public PlayDeck ( Deck d ) {
    /**/
    Card [] ca;
    /**/
    up=new CardStack();
    ca=d.getRemaining();
    down=new CardStack(ca);
  }
  /**/
  public boolean canDraw () {
    if ( down.size() == 0 ) return false;
    else                    return true;
  }
  /**/
  public void draw () {
    /**/
    Card c;
    /**/
    c=down.pop();
    up.push(c);
    /**/
    return;
  }
  /**/
  public boolean canRemove () {
    if ( up.size() == 0 ) return false;
    else                  return true;
  }
  /**/
  public Card remove () {
    return up.pop();
  }
  /**/
  public boolean canFlip () {
    /**/
    if ( size() == 0 ) {
      return false;
    }
    else {
      if ( down.size() == 0 ) return true;
      else                    return false;
    }
  }
  /**/
  public void flip () {
    /**/
    int size;
    Card c;
    /**/
    size=size();
    for ( int i=0; i<size; ++i ) {
      c=up.pop();
      down.push(c);
    }
    /**/
    return;
  }
  /**/
  public Card getTopCard () {
    return up.getTopCard();
  }
  /**/
  public String toString () {
    /**/
    Card topUp;
    String rv;
    /**/
    rv="";
    topUp=up.getTopCard();
    if ( topUp == null ) rv += Card.EMPTY;
    else                 rv += String.format("%4s",topUp.toString());
    rv += " ";
    if ( down.size() == 0 ) rv += Card.EMPTY;
    else                    rv += Card.DOWN;
    /**/
    return rv;
  }
  /**/
  public int size () {
    return up.size()+down.size();
  }
}
