public class Deck {
  /**/
  private int currentCard;
  private Card [] ca;
  /**/
  public Deck () {
    /**/
    currentCard=0;
    init();
  }
  /**/
  public Card [] getRemaining () {
    /**/
    int len;
    Card [] rv;
    /**/
    len=52-currentCard;
    rv=new Card [len];
    for ( int i=0; i<len; ++i ) rv[i]=ca[i+currentCard];
    /**/
    return rv;
  }
  /**/
  public Card deal () {
    /**/
    Card rv;
    /**/
    rv=ca[currentCard];
    ++currentCard;
    /**/
    return rv;
  }
  /**/
  private void init () {
    /**/
    int k;
    int [] randomList;
    Card [] unshuffled;
    /**/
    unshuffled=new Card [52];
    k=0;
    for ( int v=0; v<13; ++v ) {
      for ( int s=0; s<4; ++s ) {
        unshuffled[k++]=new Card(v+1,s);
      }
    }
    /**/
    randomList=randomList();
    ca=new Card [52];
    for ( int i=0; i<52; ++i ) ca[i]=unshuffled[randomList[i]];
    /**/
    return;
  }
  /**/
  private static int [] randomList () {
    /**/
    int ri;
    int [] rv;
    /**/
    rv=new int [52];
    for ( int i=0; i<52; ++i ) rv[i]=52;
    /**/
    for ( int i=0; i<52; ++i ) {
      while ( true ) {
        ri=(int)(52.0*Math.random());
        if ( !contains(ri,rv) ) {
          rv[i]=ri;
          break;
        }
      }
    }
    /**/
    return rv;
  }
  /**/
  private static boolean contains ( int n, int [] list ) {
    /**/
    for ( int i=0; i<52; ++i ) {
      if ( list[i] == n ) return true;
    }
    return false;
  }
}
